/* FMenu.cc
**
** DCFloys
** (c)2001 Paul Boese a.k.a. Axlen
**
** A cheap little menu class
*/


#include "headers.h"
#include "FMenu.h"
extern "C" {
	#include "text.h"
}

void FloyMenu::add(int min, int max, int* pval, char *pformat) {
	Menuitem* madd;	
	if (mlist == NULL) {
		mlist = (Menuitem*) malloc(sizeof(Menuitem));
		mlist->prev = NULL;
		mlist->next = NULL;
		madd = mcur = mtail = mlist;
	} else {
		madd = (Menuitem*) malloc(sizeof(Menuitem));
		mtail->next = madd;
		madd->prev = mtail;
		madd->next = NULL;
		mtail = madd;
	}
	madd->min = min;
	madd->max = max;
	madd->pvalue = pval;
	madd->pformat = (char*) malloc(strlen(pformat)+1); 
	memcpy(madd->pformat, pformat, strlen(pformat)+1);
	printf("[***]fm->add = %d\n", strlen(pformat)+1);
}
void FloyMenu::next() {
	if (mcur == NULL) return;
	if (mcur->next != NULL) {
		// point to next menu item
		mcur = mcur->next;
	} else {
		// wrap around to first menu item
		mcur = mlist;
	}
}

void FloyMenu::prev() {
	if (mcur == NULL) return;
	if (mcur->prev != NULL) {
		// point to prev menu item
		mcur = mcur->prev;
	} else {
		// wrap around to last menu item
		mcur = mtail;
	}
}
	
void FloyMenu::inc() {
	int tmp;
	if (mcur == NULL) return;
	tmp = *mcur->pvalue;
	tmp++;
	if (tmp > mcur->max)
		return;
	(*mcur->pvalue) = tmp;
}

void FloyMenu::dec() {
	int tmp;
	if (mcur == NULL) return;
	tmp = *mcur->pvalue;
	tmp--;
	if (tmp < mcur->min)
		return;
	(*mcur->pvalue) = tmp;
}

void FloyMenu::draw(int x, int y, int yinc) {
	Menuitem* pmi = mlist;
	int cy = y;
	char buf[80];
	while (pmi != NULL) {
		sprintf(buf, pmi->pformat, *pmi->pvalue);
		if (pmi == mcur) {
			font_draw_string(x,cy,0.1f,1.0f,0.2f,0.9f,0.2f, buf);
		} else {
			font_draw_string(x,cy,0.1f,0.5f,0.2f,0.9f,0.2f, buf);
		}
		cy += yinc;
		pmi = pmi->next;
	}
}

Menuitem* FloyMenu::mlist = NULL;
Menuitem* FloyMenu::mtail = NULL;
Menuitem* FloyMenu::mcur = NULL;

/* vi:tabstop=4
*/
