/* dcfloys.cc
**
** DCFloys
** (c)2001 Paul Boese a.k.a. Axlen
** Based on Floys Java Applet written by Ariel Dolan http:://www.aridolan.com/
**
** This code is butt ugly... but then it's still only test code... right =)
** This code is butt ugly empirical experimentation on my part.  I can see
** that I have much to learn.  The articles at gamedev.net and hene are
** helpful, but I have a thick skull and this 3d stuff is gonna take a while
** to sink in.
**
** release version 0.0.0
** 15 November 2001
*/

#include "headers.h"
extern "C" {
	#include "text.h"
}
#include <math.h>
#include "ship.h"
#include "mars.h"
#include "TDObject.h"
#include "Floy.h"
#include "FMenu.h"

// LCD image
#include "dcfloys_lcd.h"

#define DFFL 14                 // default number of floys
#define MXFL 20                 // max floys
#define MXNB 5                  // max neighbors
#define DPAD_REPEAT_INTERVAL 8  // frames

/* Load a texture using pcx_load_texture and glKosTex2D */
void loadtxr(const char *fn, GLuint *txr) {
	uint32 txaddr;
	int w, h;
	if (pcx_load_texture(fn, 1, 0, &txaddr, &w, &h) < 0) {
		printf("can't load %s\n", fn);
		return;
	}

	glGenTextures(1, txr);
	glBindTexture(GL_TEXTURE_2D, *txr);
	glKosTex2D(GL_RGB565_TWID, w, h, txaddr);
}

static int fps_count = 0;
static char fps[32];

void thd_fps(void *v) {
	while(1) {
		thd_sleep(1000);
		sprintf(fps, "%3d fps", fps_count);
		fps_count = 0;
	}
}

// a hacked routine from snoozy's othello
void write_lcd(uint8 c) {
	uint8 lcd=0;
	cont_cond_t cond;
	uint8 bitmap[48*32/8] = {0};
	int x, y, xi, xb;

	if (cont_get_cond(c, &cond) < 0)
		return;
	
	lcd = maple_first_lcd();
	for (y=0; y<32; y++) {
		for (x=0; x<48; x++) {	
			xi = x / 8;
			xb = 0x80 >> (x % 8);
			if (dcfloys_lcd_xpm[(31-y)*48+(47-x)] == '.') {
				bitmap[y*(48/8)+xi] |= xb;
			}
		}
	}
	vmu_draw_lcd(lcd, bitmap);
}

// Display a full screen picture - fade in/out over n seconds
void picture_wait(GLuint texture, int seconds) {
	int frames = 60*seconds; 
	
	// vars for fade effects 
	float a, r, dr;
	r = dr = F_PI/frames;

	glEnable(GL_KOS_AUTO_UV);
	glBindTexture( GL_TEXTURE_2D, texture);

	while (frames) {
		glKosBeginFrame();
		glLoadIdentity();

		// Scale (read stretch) the image to full screen size.
		// Original image was 640x480, but had to be squished into a 512x512
		// square to make the pvr happy.  Here we essentially un-squish it.
		glTranslatef(0.0f, 0.0f, -(480.0f/640.0f));
		glScalef(640.0f/480.0f, 1.0f, 0.0f);
		
		glBegin(GL_QUADS);
		
		// fade in and out
		a = fsin(r);
		glColor3f(a, a, a);

		glVertex3f(-1.0f, 1.0f, 1.0f);
		glVertex3f(1.0f, 1.0f, 1.0f);
		glVertex3f(1.0f, -1.0f, 1.0f);
		glVertex3f(-1.0f, -1.0f, 1.0f);
	
		glEnd();

		glKosFinishFrame();
		frames--; r += dr;
	}	
	glDisable(GL_KOS_AUTO_UV);
}

// This should probably be in the Floy class
void randmize(Floy** pf, int num_floys) {
	for(int i=0; i<num_floys; i++) {
		for(int j=0; j<pf[i]->numnb; j++) {
			int n=randnum(num_floys);
			pf[i]->neighbors[j]=pf[n];
		}
	}
}


extern uint8 romdisk[];

int main(void) {
	uint8 c;
	cont_cond_t cond;

	float F_PI05 = F_PI/2.0f;
	float F_PI025 = F_PI/4.0f;
	float F_PI2 = F_PI*2.0f;
			
	char floy0buf0[80];
	char floy0buf1[80];
	char floyView0[80];
	char floyType0[80];
	
	// Menu parameter defaults
	int number_floys = DFFL;           // default number of floys
	int neighbors = 3;                 // some reasonable default values
	int acceleration = 3;
	int max_velocity = 200;
	int bounce_velocity = 20;	
	int center_attraction = 30;
	int reverse_distance = 200;
	int chase_distance = 25;
	int pan_distance = 60;
	int pan_height = 170;
	
	// controller toggles and flags
	int stranger = 0;
	int flying = 0;
	int fmenu = 0;
	int dpad = 0;
	int dpadrep = DPAD_REPEAT_INTERVAL;
	
	/* Initialize KOS */
	printf("[dcFloys] Kos Initialing\n");

	kos_init_all(THD_ENABLE | TA_ENABLE, romdisk);

	printf("[dcFloys] glKos Initialing\n");

	/* Get basic stuff initialized */
	glKosInit();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(30.0f, 640.0f / 480.0f, 0.1f, 100.0f);
	glMatrixMode(GL_MODELVIEW);
	glEnable(GL_TEXTURE_2D);

	printf("[dcFloys] Loading Textures and 3D Objects\n");
	
	Ship* ship;
	Mars* mars;

	// something is amis when I use the Text module. the first
	// texture is getting trashed.  just load it twice for now.
	GLuint tex_ship, tex_dummy, tex_mars, tex_title, tex_acks;
	loadtxr("/rd/ship.pcx", &tex_dummy);
	
	loadtxr("/rd/martian_ls.pcx", &tex_mars);
	mars = (Mars*) new Mars(tex_mars);

	loadtxr("/rd/ship.pcx", &tex_ship);
	ship = (Ship*) new Ship(tex_ship);

	loadtxr("/rd/dcFloys-title.pcx", &tex_title);
	loadtxr("/rd/acks.pcx", &tex_acks);

	text_init();
	
	// Setup menu
	printf("[dcFloys] Initializing Menu\n");
	FloyMenu* fm = (FloyMenu*) malloc(sizeof(FloyMenu));
	//      min/max  pvalue             pformat
	fm->add(1, MXFL, &number_floys,		"Num Floys           %02d");
	fm->add(1, MXNB, &neighbors,		"Num Neighbors        %d");
	fm->add(1, 20, &acceleration,		"Acceleration        %02d");
	fm->add(10, 200, &max_velocity,		"Max Velocity       %03d");
	fm->add(10, 200, &bounce_velocity,	"Bounce Velocity    %03d");
	fm->add(1, 100, &center_attraction,	"Center Attraction  %03d");
	fm->add(10, 200, &reverse_distance,	"Reverse Distance   %03d");
	fm->add(5, 90, &chase_distance,		"Chase Distance      %02d");
	fm->add(10, 90, &pan_distance,		"Pan Distance        %02d");
	fm->add(50, 300, &pan_height,		"Pan Height         %03d");


	// Create floys
	printf("[dcFloys] Intializing Floys\n");	

	Floy** floys;
	floys = (Floy**) malloc(MXFL*sizeof(Floy*));
	
	for(int i=0; i<MXFL; i++) {
		floys[i] = (Floy*) new Floy(MXFL,MXNB,i,2000.0f,2000.0f,1600.0f);
		//floys[i]->Carp();
	}
	printf("\n");

	// Set the static dcFloy parameters; i.e. that shared ones.
	floys[0]->params(
		neighbors, (float)reverse_distance,
		(float)acceleration/100.0f,
		(float)center_attraction/1000.0f,
		(float)max_velocity/10.0f,
		(float)bounce_velocity/10.0f);	

	// Randomize floys
	randmize(floys, number_floys);
	
	/* Track Frames per Second */ 
	thd_create(thd_fps, NULL);
	
	irq_enable();

	printf("[dcFloys] Entering main loop\n");

	c = maple_first_controller();
	write_lcd(c);
	
	picture_wait(tex_title, 10);

	/* DCFloys Main loop */
	while(1) {
		/* Check key status */
		if (cont_get_cond(c, &cond) < 0)
			break;
		if (!(cond.buttons & CONT_START))
			break;

		if (!(cond.buttons & CONT_DPAD_UP)) {
			if (dpad == 0) {
				dpad |= 0x1000;
				if (fmenu & 1) {
					fm->prev();
				} else
					;
			}
		} else
			dpad &= ~0x1000;

		if (!(cond.buttons & CONT_DPAD_DOWN)) {
			if (dpad == 0) {
				dpad |= 0x0100;
				if (fmenu & 1) {
					fm->next();
				} else
					;
			}
		} else
			dpad &= ~0x0100;
		
		if (!(cond.buttons & CONT_DPAD_LEFT)) {
			if (dpad == 0) {
				dpad |= 0x0001;
				if (fmenu & 1) {
					fm->dec();
					if (number_floys < neighbors) neighbors = number_floys;
					floys[0]->params(
						neighbors, (float)reverse_distance,
						(float)acceleration/100.0f,
						(float)center_attraction/1000.0f,
						(float)max_velocity/10.0f,
						(float)bounce_velocity/10.0f);	
					randmize(floys, number_floys);
				} else
					;
			}
		} else
			dpad &= ~0x0001;

		if (!(cond.buttons & CONT_DPAD_RIGHT)) {
			if (dpad == 0) {
				dpad |= 0x0010;
				if (fmenu & 1) {
					fm->inc();
					if (neighbors > number_floys) neighbors--;
					floys[0]->params(
						neighbors, (float)reverse_distance,
						(float)acceleration/100.0f,
						(float)center_attraction/1000.0f,
						(float)max_velocity/10.0f,
						(float)bounce_velocity/10.0f);	
					randmize(floys, number_floys);
				} else
					;
			}
		} else
			dpad &= ~0x0010;
		
		// cheap dpad hold and repeat...
		if (dpad != 0) {
			dpadrep--;
			if (dpadrep < 0) {
				dpadrep = DPAD_REPEAT_INTERVAL;
				dpad = 0;
			}
		} else
			dpadrep = DPAD_REPEAT_INTERVAL;
			

		if (!(cond.buttons & CONT_B)) {
			if (!(stranger & 0x1000)) {
				if (stranger == 0)
					stranger = 0x1001;
				else
					stranger = 0x1000;
			}
		} else
			stranger &= ~0x1000;

		if (!(cond.buttons & CONT_X)) {
			if (!(flying & 0x1000)) {
				if (flying == 0)
					flying = 0x1001;
				else
					flying = 0x1000;
			}
		} else
			flying &= ~0x1000;

		if (!(cond.buttons & CONT_Y)) {
			if (!(fmenu & 0x1000)) {
				if (fmenu == 0)
					fmenu = 0x1001;
				else
					fmenu = 0x1000;
			}
		} else
			fmenu &= ~0x1000;

		/* Begin frame */
		glKosBeginFrame();

		glLoadIdentity();

		if (stranger & 1){
			// Floy 0 is now an interloper!
			if (floys[0]->type != 1) {
				floys[0]->type = 1;
			}
		} else {
			// Floy 0 is now just one of the guys =)
			floys[0]->type = 0;
		}

		// Camera
		if (flying & 1) {
			// Flying camera - follows floy[0]
			glRotatef(floys[0]->rx, -F_PI05, 0.0f, 0.0f);
			glRotatef(floys[0]->ry, 0.0f, -F_PI05, 0.0f);
			glRotatef(floys[0]->rz, 0.0f, 0.0f, -F_PI025);

			glTranslatef((-floys[0]->x-chase_distance/2)/24.0f,
						(-floys[0]->y-chase_distance/2)/24.0f,
						(-floys[0]->z-chase_distance)/24.0f);
		} else {
			// Far away vantage point - Tries to track floy[0]
			float cx, cy, cz, cs;
			cx = 0.0f - floys[0]->x;
			cy = 0.0f - floys[0]->y;
			cz = (float)-pan_distance - floys[0]->z;
			cs = fsqrt(cx*cx + cz*cz + cy*cy);
			glTranslatef( cx/24.0f, cy/24.0f, (float)-pan_distance);
			glRotatef( cx/cs, F_PI05, 0.0f, 0.0f);
			glRotatef( cy/cs, 0.0f, F_PI05, 0.0f);
			// no z here rotation cuz you don't wanna get seasick =)
		}

		// World Landscape
		glPushMatrix();
		glTranslatef( 0.0f, 300.0f-(float)pan_height, 0.0f );
		glScalef(250.0f, 250.0f, 250.0f);
		mars->setColor(0.5f, 0.5f, 0.5f);
		mars->draw();
		glPopMatrix();

		/* Process and draw Floys */
		for(int i=0; i<number_floys; i++) {
			
			floys[i]->GetNeighbors();
			floys[i]->Process();
			
			glPushMatrix();
			glTranslatef(floys[i]->x/24.0f, floys[i]->y/24.0f, (floys[i]->z/24.0f));
			glRotatef(floys[i]->rx, F_PI05, 0.0f, 0.0f);
			glRotatef(floys[i]->ry, 0.0f, F_PI05, 0.0f);
			glRotatef(floys[i]->rz, 0.0f, 0.0f, F_PI05);
			glScalef(0.3f, 0.3f, 0.3f);
			
			if (floys[i]->type == 1)
				ship->setColor(1.0f, 0.4f, 0.4f);
			else if (i == 0)
				ship->setColor(0.4f, 1.0f, 0.4f);
			else
				ship->setColor(1.0f, 1.0f, 1.0f);

			ship->draw();
			glPopMatrix();
			
		}
		if ((500 - randnum(1000)) < -470) randmize(floys, number_floys);

		sprintf(floy0buf0, "POS[%+04d %+04d %+04d] V[%+04d %+04d %+04d]",
						(int)floys[0]->x,
						(int)floys[0]->y,
						(int)floys[0]->z,
						(int)(floys[0]->vx * 10),
						(int)(floys[0]->vy * 10),
						(int)(floys[0]->vz * 10));

		sprintf(floy0buf1, "ROT[%+03d %+03d %+03d] VEC[%+04d %+04d %+04d]",
						(int)(floys[0]->rx * 100),
						(int)(floys[0]->ry * 100),
						(int)(floys[0]->rz * 100),
						(int)(floys[0]->a * 10),
						(int)(floys[0]->b * 10),
						(int)(floys[0]->c * 10));
		
		sprintf(floyView0, "[X] %s", (flying & 1)?"Chase":"Pan");
		sprintf(floyType0, "[B] %s", (stranger & 1)?"Intruder":"Friend");

		/* Finish the frame */
		//glKosFinishFrame();
		ta_commit_eol();
		font_draw_string(10,10,0.1f,0.5f,0.9f,0.9f,0.9f, fps);
		font_draw_string(10,30,0.1f,0.5f,0.9f,0.9f,0.0f, floyView0);
		font_draw_string(10,50,0.1f,0.5f,0.1f,0.1f,1.0f, floyType0);
		font_draw_string(10,70,0.1f,0.5f,0.1f,1.0f,0.1f, "[Y] Menu");
		font_draw_string(10,435,0.1f,0.5f,0.9f,0.9f,0.9f, floy0buf0);
		font_draw_string(10,455,0.1f,0.5f,0.9f,0.9f,0.9f, floy0buf1);
		if (fmenu & 1) fm->draw(200, 70, 30);

		//pvr_dummy_poly(TA_TRANSLUCENT);
		ta_commit_eol();
		ta_finish_frame();
		fps_count++;
	}

	picture_wait(tex_acks, 30);

	printf("[dcFloys] Exited main loop\n");
	kos_shutdown_all();
	return 0;
}

/* vi:tabstop=4
*/
